////////////////////////////////////////////////////////////////////////////////
/// @brief handler factory
///
/// @file
///
/// DISCLAIMER
///
/// Copyright 2010-2011 triagens GmbH, Cologne, Germany
///
/// Licensed under the Apache License, Version 2.0 (the "License");
/// you may not use this file except in compliance with the License.
/// You may obtain a copy of the License at
///
///     http://www.apache.org/licenses/LICENSE-2.0
///
/// Unless required by applicable law or agreed to in writing, software
/// distributed under the License is distributed on an "AS IS" BASIS,
/// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
/// See the License for the specific language governing permissions and
/// limitations under the License.
///
/// Copyright holder is triAGENS GmbH, Cologne, Germany
///
/// @author Dr. Frank Celler
/// @author Copyright 2009-2011, triAGENS GmbH, Cologne, Germany
////////////////////////////////////////////////////////////////////////////////

#include "RestHandlerFactory.h"

#include <Rest/RestModel.h>

namespace triagens {
  namespace rest {

    // -----------------------------------------------------------------------------
    // HttpHandlerFactory methods
    // -----------------------------------------------------------------------------

    pair<size_t, size_t> RestHandlerFactory::sizeRestrictions () {
      static size_t m = (size_t) -1;

      if (model == 0) {
        return make_pair(m, m);
      }
      else {
        RestModel::Extensions* extensions = model->getExtensions();

        if (extensions == 0) {
          return make_pair(m, m);
        }
        else {
          return extensions->sizeRestrictions();
        }
      }
    }
  }
}
